let chartManager = new ChartManager();

//#region MAIN FUNCTIONS
function set_chart() {

    if(chartManager.isModuleSet() == false) return;

    let chartCounter = 0;

    $('.LimitlessBarChart').each(function() {

        chartCounter++;
        let elementChart = $(this);
        elementChart.attr('id', 'LimitlessBarChart' + chartCounter);

        init_chart(elementChart[0].id);

    });

}
function init_chart(chartId) {

    // Define element
    let chartElement = document.getElementById(chartId);

    if (chartElement) {

        let elementObject = $(chartElement);

        let chartInstance = echarts.init(chartElement);

        chartInstance.showLoading(chartManager.defaultLoadingOptions);

        set_data(elementObject, function(options) {
            chartInstance.hideLoading();
            chartInstance.setOption(options);
            chartManager.setResizeEvent(chartElement, chartInstance);
        })
    }
}
function set_data(elementObject, callback) {

    setTimeout(function() {

        let options;

        let objectData = elementObject.attr('data') ? JSON.parse(elementObject.attr('data')) : null;
        let rawData = objectData?.rawData ?? (elementObject.attr('raw') ? JSON.parse(elementObject.attr('raw')) : null);

        if(rawData == null) {

            // variables (this will be set by user)

            // unique attributes of bar chart
            let title = objectData?.title ?? (elementObject.attr('title') ?? null);
            let horizontal = objectData?.horizontal ?? (elementObject.attr('horizontal') == 'true' || elementObject.attr('horizontal') == true); // default false
            let showBarValues = objectData?.barValues ?? ((elementObject.attr('bar-values') == 'true' || elementObject.attr('bar-values') == true) ?? false); // series data option

            let yAxisLabelValueFormat = chartManager.getYAxisLabelValueFormat(objectData, elementObject);

            let stacked = chartManager.getSeriesStacked(objectData, elementObject);
            let markLine = chartManager.getSeriesMarkLine(objectData, elementObject);

            let categories = chartManager.getChartCategories(objectData, elementObject);
            let series = chartManager.getChartSeries(objectData, elementObject);

            let seriesNames = series && series.map(function(item){ return item.name });
            let seriesObject = setSeries(series, stacked, markLine, showBarValues, horizontal);

            // Options
            options = {

                // Chart title
                title: setTitle(title),

                // Define colors
                color: chartManager.getColors(objectData, elementObject),

                // Global text styles
                textStyle: chartManager.defaultGlobalTextStyle,

                // Chart animation duration
                animationDuration: chartManager.getAnimationDuration(objectData, elementObject),

                // Setup grid
                grid: setGrid(),

                // Add legend
                legend: setLegend(seriesNames),

                // Add tooltip
                tooltip: setTooltip(),

                // Horizontal axis
                xAxis: horizontal ? setYAxis(yAxisLabelValueFormat) : setXAxis(categories),

                // Vertical axis
                yAxis: horizontal ? setXAxis(categories) : setYAxis(yAxisLabelValueFormat),

                // Add series
                series: seriesObject
            };

        } else {
            options = rawData;
        }

        callback(options);

    }, 1000);

}
//#endregion

//#region FUNCTIONS FOR OPTIONS
function setSeries(seriesData, stacked, markLine, showBarValues, horizontal = false) {

    // uses series options if available else use global options.
    let seriesArray = [];

    if(!seriesData || seriesData.length == 0) return [];

    for(let i = 0; i < seriesData.length; i++) {

        let series = {
            name: seriesData[i].name,
            type: seriesData[i].type ?? 'bar',
            data: seriesData[i].data,
            stack: seriesData[i].stacked ?? stacked,
            itemStyle: {
                normal: {
                    label: {
                        show: seriesData[i].showBarValues ?? showBarValues,
                        position: horizontal ? 'insideRight' : 'top',
                        textStyle: {
                            fontWeight: 500
                        }
                    }
                }
            },
        }

        chartManager.setSeriesMarkLine(series, seriesData[i], markLine);

        seriesArray.push(series);

    }

    return seriesArray;
}
function setXAxis(categories) {

    let x = {
        type: 'category',
        axisLabel: {
            color: '#fff'
        },
        axisLine: {
            lineStyle: {
                color: 'rgba(255,255,255,0.25)'
            }
        },
        splitLine: {
            show: true,
            lineStyle: {
                color: 'rgba(255,255,255,0.1)',
                type: 'dashed'
            }
        }
    };

    if(categories != null) {
        x.data = categories;
    }

    return x;
}
function setYAxis(yAxisLabelValueFormat) {

    return {
        type: 'value',
        axisLabel: {
            formatter: yAxisLabelValueFormat,
            color: '#fff'
        },
        axisLine: {
            lineStyle: {
                color: 'rgba(255,255,255,0.25)'
            }
        },
        splitLine: {
            lineStyle: {
                color: 'rgba(255,255,255,0.1)'
            }
        },
        splitArea: {
            show: true,
                areaStyle: {
                color: ['rgba(255,255,255,0.01)', 'rgba(0,0,0,0.01)']
            }
        }
    };
}
function setLegend(legendData) {
    return {
        data: legendData,
        itemHeight: 8,
        itemGap: 20,
        textStyle: {
            color: '#fff'
        }
    }
}
function setTitle(title) {

    if(title == null) return null;

    return {
        text: title,
        textStyle: {
            color: '#fff'
        }
    }

}
function setTooltip() {
    return {
        trigger: 'axis',
        backgroundColor: 'rgba(255,255,255,0.9)',
        padding: [10, 15],
        textStyle: {
            color: '#222',
            fontSize: 13,
            fontFamily: 'Roboto, sans-serif'
        },
        axisPointer: {
            type: 'shadow',
            shadowStyle: {
                color: 'rgba(255,255,255,0.1)'
            }
        }
    }
}
function setGrid() {

    return {
        left: 0,
        right: 40,
        top: 50,
        containLabel: true
    };

}
//#endregion

$(document).ready(function() { set_chart(); });